REM &1 = REQPRO_DATA
REM &2 = SMALL
REM &3 = MEDIUM
REM &4 = LARGE
REM &5 = REQPRO_INDEX
REM &6 = USR

DEFINE ROLE=&6._role


/* New columns on existing tables */
ALTER TABLE RqRequirementHistory ADD (FLAGS NUMBER(10) DEFAULT 0 NOT NULL) ;
ALTER TABLE RqDocumentHistory ADD (FLAGS NUMBER(10) DEFAULT 0 NOT NULL) ;
ALTER TABLE RqProjectHistory ADD (FLAGS NUMBER(10) DEFAULT 0 NOT NULL) ;
ALTER TABLE RqProjects ADD (WEBSERVER VARCHAR(255));


/* Package Security table for Oracle */

CREATE TABLE RQPACKAGEUSERS (
       PACKAGEID            NUMBER(10) DEFAULT 0 NOT NULL,
       USERGROUPID          NUMBER(10) DEFAULT 0 NOT NULL,
       PACKAGEACCESSRIGHTS         NUMBER(3) DEFAULT NULL,
       REQUIREMENTACCESSRIGHTS     NUMBER(3) DEFAULT NULL,
       DOCUMENTACCESSRIGHTS        NUMBER(3) DEFAULT NULL,
       VIEWACCESSRIGHTS            NUMBER(3) DEFAULT NULL
)TABLESPACE &1
STORAGE(INITIAL &3 NEXT &3 PCTINCREASE 0);


ALTER TABLE RQPACKAGEUSERS
       ADD  ( CONSTRAINT RQPACKAGEUSERS_PK
	PRIMARY KEY (PACKAGEID, USERGROUPID) USING INDEX
      TABLESPACE &5 STORAGE(INITIAL &2 NEXT &2 PCTINCREASE 0));

ALTER TABLE RQPACKAGEUSERS
       ADD  ( CONSTRAINT RQPKGUSERS_USERGROUPID_FK FOREIGN KEY (USERGROUPID)
	REFERENCES RQUSERGROUPS ON DELETE CASCADE);

ALTER TABLE RQPACKAGEUSERS
       ADD  ( CONSTRAINT RQPKGUSERS_PKGID_FK FOREIGN KEY (PACKAGEID)
	REFERENCES RQPACKAGES ON DELETE CASCADE);

/* Resource Objects */

CREATE TABLE RQRESOURCES (
       ID                   NUMBER(10) DEFAULT 0 NOT NULL,
       NAME                 VARCHAR2(255) NOT NULL,
       TYPE                 VARCHAR2(255) NOT NULL,
       REQUIREMENTID        NUMBER(10) ,
       RESOURCEOBJ          LONG RAW null,
       VERSIONDATETIME      DATE DEFAULT SYSDATE NOT NULL,
       RQGUID               VARCHAR2(40) NOT NULL ,
       FLAGS NUMBER(10) DEFAULT 0 NOT NULL
)TABLESPACE &1
STORAGE(INITIAL &4 NEXT &4 PCTINCREASE 0);
 

ALTER TABLE RQRESOURCES
       ADD  ( CONSTRAINT RQRESOURCES_PK PRIMARY KEY (ID) USING INDEX
      TABLESPACE &5 STORAGE(INITIAL &2 NEXT &2 PCTINCREASE 0));


CREATE INDEX RQRESOURCES_REQUIREMENTID_X ON RQRESOURCES (REQUIREMENTID)
      TABLESPACE &5 STORAGE(INITIAL &2 NEXT &2 PCTINCREASE 0); 

CREATE INDEX RQRESOURCES_RQGUID_X ON RQRESOURCES (RQGUID) 
      TABLESPACE &5 STORAGE(INITIAL &2 NEXT &2 PCTINCREASE 0); 
 

ALTER TABLE RQRESOURCES
       ADD  ( CONSTRAINT RQRESOURCES_REQID_FK FOREIGN KEY (REQUIREMENTID)
	REFERENCES RQREQUIREMENTS ON DELETE CASCADE);

CREATE INDEX RQRES_DATE_X on RQRESOURCES (REQUIREMENTID, VERSIONDATETIME)
      TABLESPACE &5 STORAGE(INITIAL &2 NEXT &2 PCTINCREASE 0); 


INSERT INTO RQKEYS VALUES('Resource', 0);

Update rqrequisite set datastructure = 41;

grant select,insert,update,delete on RQPACKAGEUSERS to &ROLE;
grant select,insert,update,delete on RQRESOURCES to &ROLE;

commit;
